/* ********************************************************************************
 * Copyright 2017-2021 VMware, Inc.  All rights reserved. -- VMware Confidential
 * ********************************************************************************//**
 * background.js
 *
 *   This script is run in background by Chrome. It communicates
 *   with the native messaging host.
 */var Html5MMRBackground=Html5MMRBackground||function(){function j(){return window.chrome!==undefined&&chrome.runtime!==undefined}function k(){j()?new h:new i}const a={INVALID:0,SET_ENVIRONMENT_INFO:1,WRITE_LOG:2,SET_EXTENSION_VERSION:3},b={INVALID:0,LOG_MESSAGE:1,GET_ENV_INFO:2,SET_BROWSER_ACTION:3},c={INVALID:0,SET_ENABLED_STATE:1,SET_REDIR_STATE:2},d={CHROME:1,EDGE_CHROMIUM:2},e={HTML5MMR_WEB_COMMAND_FEATURE_SUPPORTED:38,HTML5MMR_WEB_COMMAND_FEATURE_SUPPORTED_RESULT:39},f={INVALID_FEATURE:0,HTML5_MMR_FEATURE:1,GPS_REDIRECTION_FEATURE:2,WEBRTC_REDIRECTION_FEATURE:3,WEBRTC_REDIRECTION_NATIVE_FEATURE:4,BROWSER_REDIRECTION_FEATURE:5};var g=function(a){this.APP_NAME=a,this.nativeHostPort=null,this.websocketPortNumber=null};g.prototype.isHTML5MMRServerReady=function(){return this.websocketPortNumber!==null},g.prototype.onMessageFromContentScript=function(a,d,e){switch(a.type){case b.GET_ENV_INFO:this.clientScript?e({port:this.websocketPortNumber,tabId:d.tab.id,responseKey:a.responseKey,clientScript:this.clientScript}):e({port:this.websocketPortNumber,tabId:d.tab.id,responseKey:a.responseKey});break;case b.SET_BROWSER_ACTION:this.executeBrowserAction(c.SET_REDIR_STATE,a.redir,d.tab.id);break;default:console.log("onMessageFromContentScript: Invalid message type.")}};var h=function(){var a=this;g.call(this,"com.vmware.html5mmr"),this.websocketConn=null,this.nativeHostVersion=0,chrome.runtime.onMessage.addListener(function(b,c,d){a.onMessageFromContentScript(b,c,d)}),this.nativeHostPort=chrome.runtime.connectNative(this.APP_NAME),this.nativeHostPort&&(this.sendExtensionVersion(),this.nativeHostPort.onDisconnect.addListener(function(){a.onNativeMessagePortDisconnect()}),this.nativeHostPort.onMessage.addListener(function(b){a.onNativeMessage(b)})),this.executeBrowserAction(c.SET_ENABLED_STATE)};h.prototype=new g,h.prototype.constructor=h,h.prototype.sendExtensionVersion=function(){var b=chrome.runtime.getManifest();if(this.nativeHostPort){var c=navigator.userAgent.indexOf("Edg")>0?d.EDGE_CHROMIUM:d.CHROME;this.nativeHostPort.postMessage({type:a.SET_EXTENSION_VERSION,version:b.version,browsertype:c})}},h.prototype.onNativeMessage=function(b){var d=this;console.log("Received a message from native messaging host."),console.log(b);if(b.type===a.SET_ENVIRONMENT_INFO){this.clearWebSocketState();if(typeof b.portNumber=="string"&&b.portNumber.length>0)try{this.websocketConn=new WebSocket("wss://view-localhost:"+b.portNumber),this.websocketConn.onopen=function(){console.log("Websocket opened, port = "+b.portNumber),d.websocketPortNumber=b.portNumber,d.executeBrowserAction(c.SET_ENABLED_STATE);var a={feature:f.HTML5_MMR_FEATURE,command:"createInstance",commandId:e.HTML5MMR_WEB_COMMAND_FEATURE_SUPPORTED,browser:"chrome"};d.websocketConn.send(JSON.stringify(a))},this.websocketConn.onmessage=function(a){var b=JSON.parse(a.data);b.commandId==e.HTML5MMR_WEB_COMMAND_FEATURE_SUPPORTED_RESULT&&(b.allow=="false"?(console.log("Html5mmr video redirection is not supported by Horizon client"),d.websocketConn.close()):console.log("Html5mmr video redirection is supported by Horizon client"))},this.websocketConn.onerror=function(){console.log("Websocket error, port = "+b.portNumber),d.clearWebSocketState()},this.websocketConn.onclose=function(){console.log("Websocket closed, port = "+b.portNumber),d.clearWebSocketState()}}catch(g){console.log("Websocket exception = "+g.message+", port = "+b.portNumber),d.clearWebSocketState()}typeof b.version=="number"&&(nativeHostVersion=b.version,console.log("Host Version: "+nativeHostVersion)),this.executeBrowserAction(c.SET_ENABLED_STATE)}else console.log("Invalid message received: "+b.type),console.log(b)},h.prototype.onNativeMessagePortDisconnect=function(){console.log("Native messaging host is disconnected."),nativeHostPort=null,this.websocketPortNumber=null},h.prototype.executeBrowserAction=function(a,b,d){switch(a){case c.SET_ENABLED_STATE:this.isHTML5MMRServerReady()?chrome.browserAction.setIcon({path:{16:"horizon-16.png"}}):chrome.browserAction.setIcon({path:{16:"horizon-16-disabled.png"}});break;case c.SET_REDIR_STATE:b?chrome.browserAction.setBadgeText({text:"REDR",tabId:d}):chrome.browserAction.setBadgeText({text:"",tabId:d});break;default:console.log("executeBrowserAction: Unknown browser action command.")}},h.prototype.onMessageFromContentScript=function(c,d,e){c.type===b.LOG_MESSAGE?(c.type=a.WRITE_LOG,this.nativeHostPort&&this.nativeHostPort.postMessage(c)):g.prototype.onMessageFromContentScript.call(this,c,d,e)},h.prototype.clearWebSocketState=function(){this.websocketConn instanceof WebSocket&&(this.websocketConn.onopen=null,this.websocketConn.onclose=null,this.websocketConn.onerror=null,this.websocketConn.onmessage=null,this.websocketConn.readyState===WebSocket.OPEN&&this.websocketConn.close(),this.websocketConn=null),this.websocketPortNumber=null,this.executeBrowserAction(c.SET_ENABLED_STATE)};var i=function(){var a=this;g.call(this,"Html5MMREdgeAppService"),this.clientScript=null,browser.runtime.onMessage.addListener(function(b,c,d){a.onMessageFromContentScript(b,c,d)}),browser.windows.onCreated.addListener(function(){a.nativeHostPort===null&&a.connectToNativeMessagingHost()}),this.retrieveClientScript(),this.connectToNativeMessagingHost(),this.executeBrowserAction(c.SET_ENABLED_STATE)};return i.prototype=new g,i.prototype.constructor=i,i.prototype.connectToNativeMessagingHost=function(a){var b=this;this.nativeHostPort=browser.runtime.connectNative(this.APP_NAME),this.nativeHostPort&&(this.nativeHostPort.onDisconnect.addListener(function(){b.onNativeDisconnect()}),this.nativeHostPort.onMessage.addListener(function(a){b.onNativeMessage(a)}))},i.prototype.onNativeMessage=function(a){a==="PORT_FAILED"?this.websocketPortNumber=null:this.websocketPortNumber=a,this.executeBrowserAction(c.SET_ENABLED_STATE)},i.prototype.onNativeDisconnect=function(){this.nativeHostPort=null,this.websocketPortNumber=null,this.executeBrowserAction(c.SET_ENABLED_STATE)},i.prototype.retrieveClientScript=function(){var a=new XMLHttpRequest,b=this;a.open("GET",browser.runtime.getURL("html5mmrPlayer.js"),!0),a.onreadystatechange=function(){a.readyState==XMLHttpRequest.DONE&&a.status==200&&(b.clientScript=this.responseText)},a.send()},i.prototype.executeBrowserAction=function(a,b,d){switch(a){case c.SET_ENABLED_STATE:this.isHTML5MMRServerReady()?browser.browserAction.setIcon({path:{20:"horizon-20.png",40:"horizon-40.png"}}):browser.browserAction.setIcon({path:{20:"horizon-20-disabled.png",40:"horizon-40-disabled.png"}});break;case c.SET_REDIR_STATE:b?browser.browserAction.setBadgeText({text:"REDR",tabId:d}):browser.browserAction.setBadgeText({text:"",tabId:d});break;default:console.log("executeBrowserAction: Unknown browser action command.")}},k(),!0}();